/**
 * Copyright 2007 Jens Kapitza
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ajaxtags.server;

import java.util.Observable;

import org.ajaxtags.xml.AjaxXmlBuilder;

/**
 * still to do
 * 
 * @author Jens Kapitza
 * @version $Revision: 1.2 $ $Date: 2007/08/05 13:29:39 $ $Author: jenskapitza $
 * 
 * 
 */
public class CallbackObservable extends Observable implements ICallback {

	private int count;

	/**
	 * init count with 0
	 */
	public CallbackObservable() {
		this.count = 0;
	}

	@Override
	public synchronized int countObservers() {
		return this.count;
	}

	final public synchronized void add(ICallbackClient o) {
		this.count++;
		this.addObserver(o);
	}

	final public synchronized void addAndWait(ICallbackClient o)
			throws InterruptedException {
		add(o);
		this.wait();
	}

	final public synchronized void quickUpdate(AjaxXmlBuilder xmlbuilder) {
		if (xmlbuilder == null) {
			throw new NullPointerException();
		}
		// es hat sich was geändert
		this.setChanged();
		this.notifyObservers(xmlbuilder);
		this.clearChanged(); // sicherstellen dass es nun wieder normal ist
		// unchanged
		// es kann ein fehler passieren wenn sich hier nichts geändert hat
		this.notifyAll(); // alle aufwäcken
		// nun ist der count wieder auf 0
		this.count = 0;
	}

}
