/**
 * Copyright 2007 Jens Kapitza
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ajaxtags.server;

import java.util.Observer;

import javax.servlet.http.HttpServletRequest;

/**
 * callback client interface
 * @author Jens Kapitza
 *
 */
public interface ICallbackClient extends Observer {
	
	/**
	 * 
	 * @return true if wait was interrupted else false;
	 */
	public boolean isInterrupted();
	
	/**
	 * to let the client listen on server just catch 
	 * @param req
	 * @throws InterruptedException
	 */
	public void catchClient(HttpServletRequest req) throws InterruptedException;
}
