/**
 * Copyright 2007 Jens Kapitza
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ajaxtags.test;

import java.util.Date;

import org.ajaxtags.server.CallbackObservable;
import org.ajaxtags.server.ICallback;
import org.ajaxtags.xml.AjaxXmlBuilder;

/**
 * a clock that is working and updated by thread
 * @author Jens Kapitza
 *
 */
public class Clock extends CallbackObservable  implements Runnable {

	static private ICallback clock;
	static private Thread run;
	
	
/**
 * 
 * @return the updateer for clock
 */
	public static ICallback getInstance() {
		if (clock == null) {
			clock = new Clock();
			run = new Thread((Runnable)clock);
			run.start();
		}
		return clock;
	}

	public void run() {
		while (true) {
			AjaxXmlBuilder xml = new AjaxXmlBuilder();
			xml.addItem("datum", String.valueOf(new Date()));
			getInstance().quickUpdate(xml);
			try {
				Thread.sleep(900);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			
		}
		
	}
	
}
