/**
 * Copyright 2007 Jens Kapitza
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ajaxtags.test;

import static junit.framework.Assert.*;

import org.ajaxtags.helpers.AjaxHtmlHelper;
import org.junit.Before;
import org.junit.Test;

/**
 * Simple Testcase for AjaxHtmlHelper
 * 
 * @author Jens Kapitza
 * @version $Revision: 1.2 $ $Date: 2007/07/22 16:29:16 $ $Author: jenskapitza $
 */
public class HtmlHelperTest {

	private String html;
	private String tagcontent, tagcontentdiv;

	/**
	 * setup the vars
	 */
	@Before
	public void setUp() {
		this.tagcontent = "das ist ein test";
		this.tagcontentdiv = this.tagcontent + " DIV";
		this.html = "<html><body><div class='klasse' id='id'>"
				+ this.tagcontentdiv + "</div><a>" + this.tagcontent
				+ "</a></body></html>";
	}

	/**
	 * test if helper find the right stuff
	 */
	@Test
	public void tagContent() {
		assertEquals(AjaxHtmlHelper.getTagContent(this.html, "a"),
				this.tagcontent);
		assertEquals(AjaxHtmlHelper.getTagContent(this.html, "div", "klasse"),
				this.tagcontentdiv);
		assertEquals(AjaxHtmlHelper.getTagContentById(this.html, "id"),
				this.tagcontentdiv);
	}

}
