/**
 * Copyright 2007 Jens Kapitza
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.ajaxtags.test;

import java.text.SimpleDateFormat;
import java.util.Random;

import org.junit.Before;
import org.junit.Test;

/**
 * Observer Test
 * 
 * @author Jens Kapitza
 * 
 */
public class ThreadTester {
	
	static Random r = new Random();

	static ObserverTest servlet = new ObserverTest();
	class ClientRequest extends Thread {
		public void run() {
			while (!interrupted()) {
				try {
					// keine daten
					sleep(r.nextInt(2000));
					servlet.getXmlContent(null, null);
				} catch (Exception e) {
					// fehler beim xml client
				}
			}
			if (isInterrupted()) {
				System.out.println("ich beende das nachfragen der Daten");
			}

		}
	}

	protected static SimpleDateFormat DATE_FORMAT = new SimpleDateFormat(
			"hh:MM:ss");

	ClientRequest[] clients = new ClientRequest[60];

	/**
	 * setup server and client
	 */
	@Before
	public void setup() {
		for (int i = 0; i < this.clients.length; i++) {
			this.clients[i] = new ClientRequest();
		}
	}

	/**
	 * test deamons
	 * 
	 * @throws InterruptedException
	 */
	@Test
	public void runDeamons() throws InterruptedException {
		for (ClientRequest r : this.clients) {
			r.start();
		}
		int count = 0;
		while (count < 40) {
			count++;
			Thread.sleep(6000);
			System.out.println(" Es sind CLIENTS am hören : " +Clock.getInstance().countObservers());
		}

		for (ClientRequest r : this.clients) {
			r.interrupt();
		}

	}

}
